// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/Graph.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/graph.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__GRAPH__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__GRAPH__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/graph__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'origin'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'vertices'
#include "tuw_multi_robot_msgs/msg/detail/vertex__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Graph & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: origin
  {
    out << "origin: ";
    to_flow_style_yaml(msg.origin, out);
    out << ", ";
  }

  // member: vertices
  {
    if (msg.vertices.size() == 0) {
      out << "vertices: []";
    } else {
      out << "vertices: [";
      size_t pending_items = msg.vertices.size();
      for (auto item : msg.vertices) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Graph & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: origin
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "origin:\n";
    to_block_style_yaml(msg.origin, out, indentation + 2);
  }

  // member: vertices
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.vertices.size() == 0) {
      out << "vertices: []\n";
    } else {
      out << "vertices:\n";
      for (auto item : msg.vertices) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Graph & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::Graph>()
{
  return "tuw_multi_robot_msgs::msg::Graph";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::Graph>()
{
  return "tuw_multi_robot_msgs/msg/Graph";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::Graph>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::Graph>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::Graph>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__GRAPH__TRAITS_HPP_
