// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/RobotGoals.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/robot_goals.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <cstdint>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'destinations'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__RobotGoals __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__RobotGoals __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RobotGoals_
{
  using Type = RobotGoals_<ContainerAllocator>;

  explicit RobotGoals_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_name = "";
    }
  }

  explicit RobotGoals_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : robot_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_name = "";
    }
  }

  // field types and members
  using _robot_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _robot_name_type robot_name;
  using _destinations_type =
    std::vector<geometry_msgs::msg::Pose_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Pose_<ContainerAllocator>>>;
  _destinations_type destinations;

  // setters for named parameter idiom
  Type & set__robot_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->robot_name = _arg;
    return *this;
  }
  Type & set__destinations(
    const std::vector<geometry_msgs::msg::Pose_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<geometry_msgs::msg::Pose_<ContainerAllocator>>> & _arg)
  {
    this->destinations = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RobotGoals
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RobotGoals
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotGoals_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RobotGoals_ & other) const
  {
    if (this->robot_name != other.robot_name) {
      return false;
    }
    if (this->destinations != other.destinations) {
      return false;
    }
    return true;
  }
  bool operator!=(const RobotGoals_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RobotGoals_

// alias to use template instance with default allocator
using RobotGoals =
  tuw_multi_robot_msgs::msg::RobotGoals_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_GOALS__STRUCT_HPP_
