// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/RobotInfo.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/robot_info.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <cstdint>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose_with_covariance__struct.hpp"
// Member 'sync'
#include "tuw_multi_robot_msgs/msg/detail/route_precondition__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__RobotInfo __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__RobotInfo __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RobotInfo_
{
  using Type = RobotInfo_<ContainerAllocator>;

  explicit RobotInfo_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    pose(_init),
    sync(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_name = "";
      this->shape = 0l;
      this->mode = 0l;
      this->status = 0l;
      this->good_id = 0l;
      this->order_id = 0l;
      this->order_status = 0l;
    }
  }

  explicit RobotInfo_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    robot_name(_alloc),
    pose(_alloc, _init),
    sync(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->robot_name = "";
      this->shape = 0l;
      this->mode = 0l;
      this->status = 0l;
      this->good_id = 0l;
      this->order_id = 0l;
      this->order_status = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _robot_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _robot_name_type robot_name;
  using _pose_type =
    geometry_msgs::msg::PoseWithCovariance_<ContainerAllocator>;
  _pose_type pose;
  using _shape_type =
    int32_t;
  _shape_type shape;
  using _shape_variables_type =
    std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>>;
  _shape_variables_type shape_variables;
  using _sync_type =
    tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>;
  _sync_type sync;
  using _mode_type =
    int32_t;
  _mode_type mode;
  using _status_type =
    int32_t;
  _status_type status;
  using _good_id_type =
    int32_t;
  _good_id_type good_id;
  using _order_id_type =
    int32_t;
  _order_id_type order_id;
  using _order_status_type =
    int32_t;
  _order_status_type order_status;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__robot_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->robot_name = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::PoseWithCovariance_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__shape(
    const int32_t & _arg)
  {
    this->shape = _arg;
    return *this;
  }
  Type & set__shape_variables(
    const std::vector<float, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<float>> & _arg)
  {
    this->shape_variables = _arg;
    return *this;
  }
  Type & set__sync(
    const tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator> & _arg)
  {
    this->sync = _arg;
    return *this;
  }
  Type & set__mode(
    const int32_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }
  Type & set__status(
    const int32_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__good_id(
    const int32_t & _arg)
  {
    this->good_id = _arg;
    return *this;
  }
  Type & set__order_id(
    const int32_t & _arg)
  {
    this->order_id = _arg;
    return *this;
  }
  Type & set__order_status(
    const int32_t & _arg)
  {
    this->order_status = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t MODE_NA =
    0;
  static constexpr int32_t MODE_IDLE =
    1;
  static constexpr int32_t MODE_SEGMENT_FOLLOWING =
    2;
  static constexpr int32_t MODE_PICKUP =
    3;
  static constexpr int32_t STATUS_DRIVING =
    0;
  static constexpr int32_t STATUS_STOPPED =
    1;
  static constexpr int32_t STATUS_DONE =
    2;
  static constexpr int32_t STATUS_BROKEN =
    3;
  static constexpr int32_t GOOD_EMPTY =
    -1;
  static constexpr int32_t GOOD_NA =
    -2;
  static constexpr int32_t SHAPE_CIRCLE =
    0;
  static constexpr int32_t ORDER_NONE =
    0;
  static constexpr int32_t ORDER_APPROACH =
    1;
  static constexpr int32_t ORDER_PICKUP =
    2;
  static constexpr int32_t ORDER_TRANSPORT =
    3;
  static constexpr int32_t ORDER_DROP =
    4;

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RobotInfo
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RobotInfo
    std::shared_ptr<tuw_multi_robot_msgs::msg::RobotInfo_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RobotInfo_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->robot_name != other.robot_name) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->shape != other.shape) {
      return false;
    }
    if (this->shape_variables != other.shape_variables) {
      return false;
    }
    if (this->sync != other.sync) {
      return false;
    }
    if (this->mode != other.mode) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->good_id != other.good_id) {
      return false;
    }
    if (this->order_id != other.order_id) {
      return false;
    }
    if (this->order_status != other.order_status) {
      return false;
    }
    return true;
  }
  bool operator!=(const RobotInfo_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RobotInfo_

// alias to use template instance with default allocator
using RobotInfo =
  tuw_multi_robot_msgs::msg::RobotInfo_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::MODE_NA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::MODE_IDLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::MODE_SEGMENT_FOLLOWING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::MODE_PICKUP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::STATUS_DRIVING;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::STATUS_STOPPED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::STATUS_DONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::STATUS_BROKEN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::GOOD_EMPTY;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::GOOD_NA;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::SHAPE_CIRCLE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::ORDER_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::ORDER_APPROACH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::ORDER_PICKUP;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::ORDER_TRANSPORT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t RobotInfo_<ContainerAllocator>::ORDER_DROP;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROBOT_INFO__STRUCT_HPP_
