// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/route_segment.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <cstdint>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'preconditions'
#include "tuw_multi_robot_msgs/msg/detail/route_precondition__struct.hpp"
// Member 'start'
// Member 'end'
#include "geometry_msgs/msg/detail/pose__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__RouteSegment __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__RouteSegment __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RouteSegment_
{
  using Type = RouteSegment_<ContainerAllocator>;

  explicit RouteSegment_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_init),
    end(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->segment_id = 0l;
      this->width = 0.0f;
    }
  }

  explicit RouteSegment_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : start(_alloc, _init),
    end(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->segment_id = 0l;
      this->width = 0.0f;
    }
  }

  // field types and members
  using _segment_id_type =
    int32_t;
  _segment_id_type segment_id;
  using _preconditions_type =
    std::vector<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>>;
  _preconditions_type preconditions;
  using _start_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _start_type start;
  using _end_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _end_type end;
  using _width_type =
    float;
  _width_type width;

  // setters for named parameter idiom
  Type & set__segment_id(
    const int32_t & _arg)
  {
    this->segment_id = _arg;
    return *this;
  }
  Type & set__preconditions(
    const std::vector<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_multi_robot_msgs::msg::RoutePrecondition_<ContainerAllocator>>> & _arg)
  {
    this->preconditions = _arg;
    return *this;
  }
  Type & set__start(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->start = _arg;
    return *this;
  }
  Type & set__end(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->end = _arg;
    return *this;
  }
  Type & set__width(
    const float & _arg)
  {
    this->width = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RouteSegment
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__RouteSegment
    std::shared_ptr<tuw_multi_robot_msgs::msg::RouteSegment_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RouteSegment_ & other) const
  {
    if (this->segment_id != other.segment_id) {
      return false;
    }
    if (this->preconditions != other.preconditions) {
      return false;
    }
    if (this->start != other.start) {
      return false;
    }
    if (this->end != other.end) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    return true;
  }
  bool operator!=(const RouteSegment_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RouteSegment_

// alias to use template instance with default allocator
using RouteSegment =
  tuw_multi_robot_msgs::msg::RouteSegment_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__STRUCT_HPP_
