// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/Vertex.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/vertex.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__VERTEX__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__VERTEX__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/vertex__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'path'
#include "geometry_msgs/msg/detail/point__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Vertex & msg,
  std::ostream & out)
{
  out << "{";
  // member: id
  {
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << ", ";
  }

  // member: valid
  {
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << ", ";
  }

  // member: path
  {
    if (msg.path.size() == 0) {
      out << "path: []";
    } else {
      out << "path: [";
      size_t pending_items = msg.path.size();
      for (auto item : msg.path) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: weight
  {
    out << "weight: ";
    rosidl_generator_traits::value_to_yaml(msg.weight, out);
    out << ", ";
  }

  // member: width
  {
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << ", ";
  }

  // member: successors
  {
    if (msg.successors.size() == 0) {
      out << "successors: []";
    } else {
      out << "successors: [";
      size_t pending_items = msg.successors.size();
      for (auto item : msg.successors) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: predecessors
  {
    if (msg.predecessors.size() == 0) {
      out << "predecessors: []";
    } else {
      out << "predecessors: [";
      size_t pending_items = msg.predecessors.size();
      for (auto item : msg.predecessors) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Vertex & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "id: ";
    rosidl_generator_traits::value_to_yaml(msg.id, out);
    out << "\n";
  }

  // member: valid
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "valid: ";
    rosidl_generator_traits::value_to_yaml(msg.valid, out);
    out << "\n";
  }

  // member: path
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.path.size() == 0) {
      out << "path: []\n";
    } else {
      out << "path:\n";
      for (auto item : msg.path) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: weight
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "weight: ";
    rosidl_generator_traits::value_to_yaml(msg.weight, out);
    out << "\n";
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << "\n";
  }

  // member: successors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.successors.size() == 0) {
      out << "successors: []\n";
    } else {
      out << "successors:\n";
      for (auto item : msg.successors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: predecessors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.predecessors.size() == 0) {
      out << "predecessors: []\n";
    } else {
      out << "predecessors:\n";
      for (auto item : msg.predecessors) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Vertex & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::Vertex>()
{
  return "tuw_multi_robot_msgs::msg::Vertex";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::Vertex>()
{
  return "tuw_multi_robot_msgs/msg/Vertex";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::Vertex>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::Vertex>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::Vertex>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__VERTEX__TRAITS_HPP_
