// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from tuw_multi_robot_msgs:msg/RouteSegment.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/route_segment.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__TRAITS_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "tuw_multi_robot_msgs/msg/detail/route_segment__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'preconditions'
#include "tuw_multi_robot_msgs/msg/detail/route_precondition__traits.hpp"
// Member 'start'
// Member 'end'
#include "geometry_msgs/msg/detail/pose__traits.hpp"

namespace tuw_multi_robot_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RouteSegment & msg,
  std::ostream & out)
{
  out << "{";
  // member: segment_id
  {
    out << "segment_id: ";
    rosidl_generator_traits::value_to_yaml(msg.segment_id, out);
    out << ", ";
  }

  // member: preconditions
  {
    if (msg.preconditions.size() == 0) {
      out << "preconditions: []";
    } else {
      out << "preconditions: [";
      size_t pending_items = msg.preconditions.size();
      for (auto item : msg.preconditions) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: start
  {
    out << "start: ";
    to_flow_style_yaml(msg.start, out);
    out << ", ";
  }

  // member: end
  {
    out << "end: ";
    to_flow_style_yaml(msg.end, out);
    out << ", ";
  }

  // member: width
  {
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RouteSegment & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: segment_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "segment_id: ";
    rosidl_generator_traits::value_to_yaml(msg.segment_id, out);
    out << "\n";
  }

  // member: preconditions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.preconditions.size() == 0) {
      out << "preconditions: []\n";
    } else {
      out << "preconditions:\n";
      for (auto item : msg.preconditions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: start
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "start:\n";
    to_block_style_yaml(msg.start, out, indentation + 2);
  }

  // member: end
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "end:\n";
    to_block_style_yaml(msg.end, out, indentation + 2);
  }

  // member: width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "width: ";
    rosidl_generator_traits::value_to_yaml(msg.width, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RouteSegment & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<tuw_multi_robot_msgs::msg::RouteSegment>()
{
  return "tuw_multi_robot_msgs::msg::RouteSegment";
}

template<>
inline const char * name<tuw_multi_robot_msgs::msg::RouteSegment>()
{
  return "tuw_multi_robot_msgs/msg/RouteSegment";
}

template<>
struct has_fixed_size<tuw_multi_robot_msgs::msg::RouteSegment>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<tuw_multi_robot_msgs::msg::RouteSegment>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<tuw_multi_robot_msgs::msg::RouteSegment>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__ROUTE_SEGMENT__TRAITS_HPP_
