// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from tuw_multi_robot_msgs:msg/StationArray.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/msg/station_array.hpp"


#ifndef TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__STATION_ARRAY__STRUCT_HPP_
#define TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__STATION_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <cstdint>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'stations'
#include "tuw_multi_robot_msgs/msg/detail/station__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__tuw_multi_robot_msgs__msg__StationArray __attribute__((deprecated))
#else
# define DEPRECATED__tuw_multi_robot_msgs__msg__StationArray __declspec(deprecated)
#endif

namespace tuw_multi_robot_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct StationArray_
{
  using Type = StationArray_<ContainerAllocator>;

  explicit StationArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit StationArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _stations_type =
    std::vector<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>>;
  _stations_type stations;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__stations(
    const std::vector<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<tuw_multi_robot_msgs::msg::Station_<ContainerAllocator>>> & _arg)
  {
    this->stations = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__StationArray
    std::shared_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__tuw_multi_robot_msgs__msg__StationArray
    std::shared_ptr<tuw_multi_robot_msgs::msg::StationArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const StationArray_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->stations != other.stations) {
      return false;
    }
    return true;
  }
  bool operator!=(const StationArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct StationArray_

// alias to use template instance with default allocator
using StationArray =
  tuw_multi_robot_msgs::msg::StationArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace tuw_multi_robot_msgs

#endif  // TUW_MULTI_ROBOT_MSGS__MSG__DETAIL__STATION_ARRAY__STRUCT_HPP_
