// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from tuw_multi_robot_msgs:srv/StationManagerControlProtocol.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/srv/station_manager_control_protocol.h"


#ifndef TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__STRUCT_H_
#define TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'LOAD'.
/**
  * request constants
  * command to load a file (addition is the file path)
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__LOAD = "load";

/// Constant 'SAVE'.
/**
  * command to save a file (addition is the file path)
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__SAVE = "save";

/// Constant 'UPDATE'.
/**
  * command to define update policy
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__UPDATE = "update";

/// Constant 'ONCE'.
/**
  * addition to publish data once on request
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__ONCE = "once";

/// Constant 'CHANGE'.
/**
  * addition to publish data on ever change
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__CHANGE = "change";

// Include directives for member types
// Member 'request'
// Member 'addition'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/StationManagerControlProtocol in the package tuw_multi_robot_msgs.
typedef struct tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request
{
  /// request
  rosidl_runtime_c__String request;
  /// addition, holds information to the request
  rosidl_runtime_c__String addition;
} tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request;

// Struct for a sequence of tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request.
typedef struct tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__Sequence
{
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__Sequence;

// Constants defined in the message

/// Constant 'EXECUTED'.
/**
  * response constants
  * response if the request could be executed successful
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response__EXECUTED = "executed";

/// Constant 'FAILED'.
/**
  * response if the request could not be executed successful
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response__FAILED = "failed";

/// Constant 'ERROR'.
/**
  * response if the request is unknown
 */
static const char * const tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response__ERROR = "error";

// Include directives for member types
// Member 'response'
// already included above
// #include "rosidl_runtime_c/string.h"

/// Struct defined in srv/StationManagerControlProtocol in the package tuw_multi_robot_msgs.
typedef struct tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response
{
  /// response string
  rosidl_runtime_c__String response;
} tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response;

// Struct for a sequence of tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response.
typedef struct tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response__Sequence
{
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event__request__MAX_SIZE = 1
};
// response
enum
{
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/StationManagerControlProtocol in the package tuw_multi_robot_msgs.
typedef struct tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event
{
  service_msgs__msg__ServiceEventInfo info;
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Request__Sequence request;
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Response__Sequence response;
} tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event;

// Struct for a sequence of tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event.
typedef struct tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event__Sequence
{
  tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} tuw_multi_robot_msgs__srv__StationManagerControlProtocol_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_CONTROL_PROTOCOL__STRUCT_H_
